/*    WIPTOKEN
 *
 *    Copyright (c) 1994--1998 Marius Seritan
 * 
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU Library General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    In short, you can use and modify this program. You can
 *    distribute the program with or without your modifications if you want,
 *    but you must not require licence fees and must provide the
 *    full source code with the distribution. If you make an application program
 *    which just calls functions from this library you may distribute that
 *    application program without source code, but also as an linkable object file, 
 *    and must distribute also this library with source code.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Revision 1.1.1.2  1996/01/17  21:51:19  mseritan
 * This is the first release by M. Seritan, with the
 * old calls removed and the help, partial internationalisation
 * and full textpads (textbuffers included) implementated.
 *
 * Revision 1.1.1.1  1995/12/25  18:33:46  dcorlan
 * This is wiport, as it remained before Marius Seritan began finishing
 * the implementation. As a new designs decision, all the wiport related
 * source files are to be kept in a single source directory.
 *
 *
 */

/* forward type definition */
typedef struct _wip_token wip_token;

/* Type definition for the tokens */

/* allowed types */
#define TOKEN_TEXT       1
#define TOKEN_PAR        2
#define TOKEN_EOF        3
#define TOKEN_MENU       4
#define TOKEN_LINK       5
#define TOKEN_IMG        7

/* allowed text properties */
#define TOKEN_TEXT_PLAIN 1

/* private type definitions */
struct _wip_token {
  short type;
  union {			
    struct {			/* for WIP_TOKEN_TEXT */
      char * contents;		
      unsigned length;
      unsigned properties;
    }  text;
    struct {			/* WIP_TOKEN_LINK */
      char * contents;
      unsigned length;
      char * link_name;
      unsigned link_len;
    }  link;
    struct {			/* WIP_TOKEN_MENU */
      char * contents;
      unsigned length;
      char * link_name;
      unsigned link_len;
    }  menu;
  }  data;
};



/* functional interface to the token package */
int wip_token_type( wip_token * tok);
void wip_token_to_string( wip_token * tok , char ** string, int * len);
int wip_token_text_set( wip_token * tok, int properties
		       , char * buffer, int len );
int wip_token_link_set( wip_token * tok, char * buffer, int len
		       , char * link_name, int link_len);
int wip_token_menuentry_set( wip_token * tok, char * buffer, int len
			    , char * link_name, int link_len);
int wip_token_par_set( wip_token * tok );
int wip_token_eof_set( wip_token * tok );


